#include "JWordCounterObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJWordCounterObj = JWordCounterObj().Register();


const char* JWordCounterObj::className() const { return "JWordCounterObj";}


JObject* JWordCounterObj::clone() const { return new JWordCounterObj(*this);}

#include <stdio.h>
// class constructor
JWordCounterObj::JWordCounterObj() {
  igm = 1;
  ogm = 20;
  wordListIdx = 0;
  wordCountIdx = 0;
  for ( int i = 0; i < MAX_WORDS; i++ ) {
	  wordHashes[i] = 0;
	  wordCounts[i] = 0;
  }
  for ( i = 0; i < MAX_OUTPUTS; i++ ) {
	  allocatedStrs[i] = NULL;
  }
}


void JWordCounterObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("ctWord"), rect);
}


boolean JWordCounterObj::inputAllowed(int n)
{ return true; } //return !inputSet(n).last();}
JString JWordCounterObj::inputTag(int n) {
  char* tag[] = {
    "word" };
  return( tag[n] );
}


int JWordCounterObj::outputType( int n ) {
	if (( n % 2 ) == 0 )
  return JStringData::id;
	else return JIntegerData::id;
}
int JWordCounterObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JWordCounterObj::outputTag(int n) {
  char* tag[] = {
	  "word1",
  "count1",
"word2",
  "count2",
  "word3",
  "count3",
  "word4",
  "count4",
  "word5",
  "count5",
  "word6", 
  "count6",
  "word7",
  "count7",
  "word8",
  "count8",
  "word9",
  "count9",
  "word10",
  "count10"};
  return( tag[n] );
}


JFRect JWordCounterObj::inputArea(int n) {
  //if ( n < ( 1 )) {
    return leftArea( n, 0, 1, 0.1, 0.8 );
  //}
}


JFRect JWordCounterObj::outputArea(int n) {
  return rightArea(n, 0, 20, 0.05, 0.9);
}


int JWordCounterObj::inputFace(int n) {
  if ( n < 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JWordCounterObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JWordCounterObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1, 0.1, 0.8);
}


JFPoint JWordCounterObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 20, 0.05, 0.9);
}


#include <malloc.h>
#include <string.h>
char* newstrcpy( char* s ) {
	char* result = (char*)malloc( strlen( s ) + 1 );
	strcpy( result, s );
	return( result );
}

void JWordCounterObj::access(int n, JLinkObj& link, const JDataType& data) {
	if (( n%2 ) == 0 ) {
		n = n/2;
		if ( wordCounts[ wordListIndex[n] ] == 0 ) {
			//JComponent::debug( "wipe out word" );
			JSTRING(data) = JString("");
		} else {
			//JComponent::debug( wordCount[n] );
			JSTRING(data) = JString( (char*)allocatedStrs[n] );
		}
	} else {
		n = n/2;
		INT(data) = wordCounts[ wordListIndex[n] ];
	}
}


void JWordCounterObj::putOutput( int wordListOffset, int count ) {
	int guyToReplace = -1;
//	char dbuf[100];
	char sbuf[100];
//	sprintf( dbuf, "putOutput wordListOffset %d, count %d", wordListOffset, count );
	//JComponent::debug( newstrcpy( dbuf ));
	for ( int i = 0; i < wordCountIdx; i++ ) {
		if ( wordListIndex[i] == wordListOffset ) {
			//sprintf( dbuf, "found existing word %s at offset %d", wordList[ wordListIndex[i] ], i );
			//JComponent::debug( newstrcpy( dbuf ));
			sprintf( sbuf, "%s", wordList[ wordListIndex[i] ] );
			if ( allocatedStrs[i] != NULL ) {
				free( allocatedStrs[i] );
			}
			allocatedStrs[i] = newstrcpy( sbuf );
			wordCount[i] = JString( allocatedStrs[i] );
			//broadcast( i*2 );
			broadcast( i*2 + 1 );
			return;
		} else if ( count > wordCounts[ wordListIndex[i]] ) {
			//sprintf( dbuf, "might replace word at offset %d", i );
			//JComponent::debug( newstrcpy( dbuf ));
			guyToReplace = i;
		}
	}
	if ( guyToReplace != -1 ) {
		//JComponent::debug( "Actually replacing a guy" );
		wordListIndex[ guyToReplace ] = wordListOffset;
		i = guyToReplace;
		sprintf( sbuf, "%s", wordList[ wordListIndex[i] ] );
		if ( allocatedStrs[i] != NULL ) {
			//JComponent::debug( "Old value:" );
			//JComponent::debug( newstrcpy( allocatedStrs[i] ));
			free( allocatedStrs[i] );
		}
		allocatedStrs[i] = newstrcpy( sbuf );
		wordCount[i] = JString( allocatedStrs[i] );
		//JComponent::debug( "New value:" );
		//JComponent::debug( wordCount[i] );
		broadcast( guyToReplace*2 );
		broadcast( guyToReplace*2 + 1);
	} else if ( wordCountIdx < 10 ) {
		//sprintf( dbuf, "Adding a new word: %s at offset %d", wordList[ wordListOffset ], wordCountIdx );
		//JComponent::debug( newstrcpy( dbuf ));
		i = wordCountIdx;
		wordListIndex[ wordCountIdx++ ] = wordListOffset;
		sprintf( sbuf, "%s", wordList[ wordListIndex[i] ] );
		if ( allocatedStrs[i] != NULL ) {
			free( allocatedStrs[i] );
		}
		allocatedStrs[i] = newstrcpy( sbuf );
		broadcast(( wordCountIdx - 1 )*2 );
		broadcast(( wordCountIdx - 1 )*2 +1);
	} 

}

int JWordCounterObj::getHashVal( char* s ) {
	int result = 0;
	while ( *s ) {
		result += *s;
		s++;
	}
	return( result );
}

void JWordCounterObj::addWord( char* w ) {
	if ( *w == 0 ) return;
	int hashVal = getHashVal( w );
	//char dbuf[100];
	//sprintf( dbuf, "addWord %s, hashVal is %d", w, hashVal );
	//JComponent::debug( newstrcpy( dbuf ));
	for ( int i = 0; i < wordListIdx; i++ ) {
		if ( hashVal == wordHashes[i] ) {
			if ( strcmp( w, wordList[i] ) == 0 ) {
				wordCounts[i]++;
				putOutput( i, wordCounts[i] );
				return;
			}
		}
	} 
	if ( wordListIdx < MAX_WORDS ) {
		wordList[ wordListIdx ] = newstrcpy( w );
		wordCounts[ wordListIdx ] = 1;
		wordHashes[ wordListIdx ] = hashVal;
		if ( wordListIdx < 10 ) {
			putOutput( wordListIdx, 1 );
		}
		wordListIdx++;
	}
}


void JWordCounterObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case WORD:
    link.access( JStringData( word ));
	addWord( word );
    break;
  default:
    break;
  }
}


