#if !defined( _JWordCounterObj_h )
#define _JWordCounterObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"


#define MAX_OUTPUTS 10
#define MAX_WORDS 1000


class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JWordCounterObj : public JAddObj {
  protected:
  public:
    enum {
      WORD };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JWordCounterObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual int inputType( int n );
    virtual int outputType( int n );
    virtual void access(int n, JLinkObj& link, const JDataType& data);
  private:

    // inputs
    JString word;

    // outputs
    JString wordCount[MAX_OUTPUTS];
	char* allocatedStrs[ MAX_OUTPUTS ];
	int wordListIndex[ MAX_OUTPUTS ];
	int wordCountIdx;
	void putOutput( int wordListOffset, int count );

	void addWord( char* w );
	int getHashVal( char* s );

	char* wordList[ MAX_WORDS ];
	int wordCounts[ MAX_WORDS ];
	int wordHashes[ MAX_WORDS ];
	int wordListIdx;
};


#endif
