#include "JWordMakerObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJWordMakerObj = JWordMakerObj().Register();


const char* JWordMakerObj::className() const { return "JWordMakerObj";}


JObject* JWordMakerObj::clone() const { return new JWordMakerObj(*this);}


// class constructor
JWordMakerObj::JWordMakerObj() {
  igm = 1;
  ogm = 1;
  internalWordIdx = 0;
}


void JWordMakerObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("mkWord"), rect);
}


boolean JWordMakerObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JWordMakerObj::inputTag(int n) {
  char* tag[] = {
    "letter" };
  return( tag[n] );
}


int JWordMakerObj::outputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
int JWordMakerObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JWordMakerObj::outputTag(int n) {
  char* tag[] = {
    "word" };
  return( tag[n] );
}


JFRect JWordMakerObj::inputArea(int n) {
  //if ( n < ( 1 )) {
    return leftArea( n, 0, 1, 0.1, 0.8 );
  //}
}


JFRect JWordMakerObj::outputArea(int n) {
  return rightArea(n, 0, 1);
}


int JWordMakerObj::inputFace(int n) {
  if ( n < 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JWordMakerObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JWordMakerObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1, 0.1, 0.8);
}


JFPoint JWordMakerObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1);
}


void JWordMakerObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    JSTRING(data) = word;
  }
}

#include <ctype.h>
void JWordMakerObj::processText( char* s ) {
	while ( *s ) {
		if ( isspace( *s ) || ( internalWordIdx == 100 )) {
			if ( internalWordIdx > 0 ) {
				word = JString( internalWord, 2 );
				broadcast( 0 );
				internalWordIdx = 0;
				internalWord[0] = 0;
			}
		} else {
			internalWord[ internalWordIdx++ ] = *s;
			internalWord[ internalWordIdx ] = 0;
		}
		s++;
	}
}

void JWordMakerObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case LETTER:
    link.access( JStringData( letter ));
	processText( letter );
    break;
  default:
    break;
  }
}


